"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useRafDebouncedValue(value) {
    var _a = react_1.useState(value), debouncedState = _a[0], setDebouncedState = _a[1];
    var queued = react_1.useRef();
    react_1.useEffect(function () {
        queued.current = requestAnimationFrame(function () { return setDebouncedState(value); });
        return function () {
            queued.current && cancelAnimationFrame(queued.current);
        };
    }, [value, setDebouncedState]);
    react_1.useEffect(function () {
        return function () {
            queued.current && cancelAnimationFrame(queued.current);
        };
    }, []);
    return [debouncedState];
}
exports.useRafDebouncedValue = useRafDebouncedValue;
//# sourceMappingURL=useRafDebouncedValue.js.map